from generate_prompt import rewrite_string_to_variable
from WoT_Thing_Description import *

# Can be used to connect the class as generated by the LLM with the class of the simulator
class Code_Entangler():

    def __init__(self, wot_td: WoT_Thing_Description, generated_simulator, real_simulator):
        self.wot_td = wot_td
        self.generated_simulator = generated_simulator
        self.real_simulator = real_simulator
        self.name = wot_td.class_name()
        print(self.name)

        self.variables = [rewrite_string_to_variable(var) for var in wot_td.properties_list()]

        self.function_mapping = dict()
        for action in wot_td.action_name_mapping.keys():
            self.function_mapping[rewrite_string_to_variable(action)] = rewrite_string_to_variable(wot_td.action_name_mapping[action])

    def add_real_device(self):
        #the first time a line staarts with 8 spaces is within the init function
        position = self.generated_simulator.index("\n        ")
        self.generated_simulator = self.generated_simulator[:position] \
            + "\n        self.real_device = {0}Simulator()".format(self.name) \
            + self.generated_simulator[position:]

    def add_action_call_and_print(self):
        # action and print calls are added at the end of every function 
        # (except of the 'init' and 'ensure_synchronization' function)

        split_by_lines = self.generated_simulator.split("\n")

        for idx,line in enumerate(split_by_lines):
            if "    def " == line[:8] and "__init__" not in line:
                #start of a function that is not the init function

                function_name = line.replace("    def ","").split("(")[0]
                original_function_name = self.function_mapping[function_name]

                variables_list = line.replace("    def ","").split("(")[1][:-2]
                variables_list = variables_list.replace(" ","")
                variables_list = variables_list.split(",")
                variables_list.pop(0) #dont need the 'self' variable

                full_call = "        self.real_device." + original_function_name + "("
                full_call += str(variables_list)[1:-1].replace("'","") + ")\n"

                print_statement = f"        print(f\"{original_function_name}("
                for variable in variables_list:
                    print_statement += "{" + variable + "},"
                
                if len(variables_list) > 0:
                    print_statement = print_statement[:-1]
                
                print_statement += ")\")"

                # find the end of the function:
                rest = split_by_lines[idx+1:]
                for idx_2, line_2 in enumerate(rest):
                    if "    def " == line_2[:8] or "    #" == line_2[:5]:
                        split_by_lines.insert(idx + idx_2 +1, full_call)
                        split_by_lines.insert(idx + idx_2 +1,  print_statement)
                        break
                    if idx_2 == len(rest) -1:
                        split_by_lines.insert(idx + idx_2 +2, full_call)
                        split_by_lines.insert(idx + idx_2 +2,  print_statement)
                        break
        
        self.generated_simulator = ""
        for line in split_by_lines:
            self.generated_simulator += line
            self.generated_simulator += "\n"

    def get_modified_code(self):
        self.add_real_device()
        self.add_action_call_and_print() # needs to be called after 'add_ensure_synchronization()'

        full_entangled_pair = self.real_simulator + "\n\n\n" + self.generated_simulator

        return full_entangled_pair
    

def main():
    wot_td = WoT_Thing_Description("prompt_examples/MP3Player.json")
    
    with open("prompt_examples/MP3Player.py") as f:
        example_generated_simulator = f.read()
    
    with open("prompt_examples/MP3PlayerSimulator.py") as f:
        example_real_simulator = f.read()
    

    weaver = Code_Entangler(wot_td,example_generated_simulator,example_real_simulator)
    pair = weaver.get_modified_code()
    print(pair)

    with open("entangled_code.py", "w") as f:
        f.write(pair)
        

if __name__ == "__main__":
    main()
 


